APPROXr <- function (x, y, xout, lorder =3, Nmax=750000 ) { 
#polynomial interpolator based on algorithms in Press et al., "Numerical Recipes"
#x must be in ascending order, no dups #NAs reported for xout out of range
#xout, the points at which the interpolation is to be done, must be given
#if(!is.loaded(symbol.For("approxd")) ) {dyn.load("/documents/PROGRAMS/APPROX.R/approxd.so")}
if(!is.loaded("approxd") ) {dyn.load("/documents/PROGRAMS/APPROX.R/approxd.so")}
if(length(x) != length (y) ) stop("Error in APPROXr:  Lengths of x and y must be equal")
if(sum(is.na(x+y))!=0 | sum(is.na(xout)) !=0)stop("Error in APPROXr: NAs not allowed")
if(sum(diff(x)<=0)>0)stop("Error in APPROXr:  x must be in ascending order")
#test for dataset length;  Nmax must match the dimension given in approx_d.f
if(length(x) > Nmax)stop(paste( "Error in APPROXr",length(x)," > Nmax (=",Nmax,")") )
ltt<- which(xout >= min(x) & xout <= max(x))  # T for bounded values to be interp'd
#
x0<-xout[ltt]
nxy<-length(x);nx0y0<-length(x0)
y0<-rep(-99999,length(x0))
uu<-.Fortran("approxd",x=as.double(x),y=as.double(y),x0=as.double(x0),y0=as.double(y0),
nxy=as.integer(nxy),nx0y0=as.integer(nx0y0),order=as.integer(lorder)) # interpolates,
yy<- rep(NA,length(xout)) 
#print(names(uu))
yy[ltt]<-uu$y0
return(list(x=xout,y=yy) )
}

